﻿[<ReflectedDefinition>]
module Program

open Window
open Maze
    
type pacman = { x:int; y:int; image:string }

let anim n = (((n >>> 3) % 2)+1).ToString()
let left (dx,_) p = if dx = -1 && canGoLeft(p.x,p.y) then {p with x=p.x+dx; image="pl"+anim p.x} else p
let right (dx,_) p = if dx = 1 && canGoRight(p.x,p.y) then {p with x=p.x+dx; image="pr"+anim p.x} else p
let up (_,dy) p = if dy = -1 && canGoUp(p.x,p.y) then {p with y=p.y+dy; image="pu"+anim p.y} else p
let down (_,dy) p = if dy = 1 && canGoDown(p.x,p.y) then {p with y=p.y+dy; image="pd"+anim p.y} else p

let wrap p = 
    if p.x < 0 then { p with x = 30 * 8 }
    elif p.x > 30 * 8 then { p with x = 0 }
    else p

let step dir pacman = pacman |> left dir |> right dir |> up dir |> down dir |> wrap

let render(pacman:pacman) =
    pacman.image + ".png" |> image 
    |> position (float pacman.x, float pacman.y)

let main() =
   Keyboard.init()
   renderMaze()
   let pacman = ref { x = 16 * 8 - 7; y = 23 * 8 - 3; image = "p" }
   let rec update () =
        pacman := !pacman |> step (Keyboard.arrows())
        render !pacman
        ts.setTimeout(update, 1000. / 60.) |> ignore
   update ()
   
do FunScript.Runtime.Run(directory="Web", components=FunScript.Interop.Components.all)