﻿module Pacman

let leftExtent, rightExtent = 0, 30 * 8

type pacman = { x:int; y:int }

let wrap p = 
    if p.x < leftExtent then { p with x = rightExtent }
    elif p.x > rightExtent then { p with x = leftExtent }
    else p

module Tests =
    open System
    open NUnit.Framework

    [<Test>]
    let ``pacman should not wrap withing left and right extents`` () =
        let x = leftExtent + (rightExtent - leftExtent)/2
        let p = wrap { x = x; y = 0 }
        Assert.AreEqual(x, p.x)

    [<Test>]
    let ``pacman should wrap from right to left beyond right extent`` () =
        let p = wrap { x = rightExtent+1; y =0 }
        Assert.AreEqual(0, p.x)

    [<Test>]
    let ``pacman should wrap from left to right beyond left extend`` () =
        // TODO: implement this
        raise(NotImplementedException())


